var d = document;
var previousContentHeight = 0;
var documentReady = function() {
	monitorImageLoading();
	attachClickEventToLinks();
};
var attachClickEventToLinks = function() {
	var links = document.getElementsByTagName("a");
	for (var i = 0; i < links.length; i++) {
		var link = links[i];
		link.addEventListener("click", function(event) {
			var url = this.href;
		});
	}
};
var monitorImageLoading = function() {
	var images = d.getElementsByClassName('img-body');
	for (i = 0; i < images.length; i++) {
		var image = images[i];
		updateDimensionOfImage(image);
		monitorLoadingOfImage(image);
		attachClickEventToImage(image, i);
        article.putImage(image.src, i);
	}
	tryLazyLoadImages();
	previousContentHeight = d.body.scrollHeight;
};
var updateDimensionOfImage = function(image) {
	var parentNode = image.parentNode;
	var dataWidth = getAttribute(image, 'data-width');
	var dataHeight = getAttribute(image, 'data-height');
	var actualHeight = 150;
	if (dataWidth && dataHeight) {
		var maxWidth = parentNode.offsetWidth;
		var actualWidth = Math.min(maxWidth, dataWidth);
		actualHeight = dataWidth == 0 ? 0
				: ((actualWidth / dataWidth) * dataHeight);
		var messageObj = {
			"actualWidth" : actualWidth,
			"actualHeight" : actualHeight,
			"objname" : "update image dimension"
		};
		image.style.minWidth = actualWidth + "px";
		image.style.maxWidth = actualWidth + "px";
		image.style.minHeight = actualHeight + "px";
		image.style.maxHeight = actualHeight + "px";
	}
};
var monitorLoadingOfImage = function(image) {
	var originalOnload = image.onload;
	image.onload = function() {
		try {
			if (typeof originalOnload == 'function') {
				originalOnload.apply(image);
			}
		} catch (error) {
		}
		trySendContentSizeChangedMessage();
	};
};

var tryLazyLoadImages = function() {
	var shouldDownload = shouldDownloadImage();
	if (shouldDownload) {
		return;
	}
	var images = d.getElementsByClassName('img-body');
	for (var i = images.length; i >= 0; i--) {
		tryLazyLoadImage(images[i]);
	}
};
var tryLazyLoadImage = function(image) {
	if (!image) {
		return;
	}
	if (image.complete) {
		return;
	}
	var src = image.src;
	image.src = '';
	var parentNode = image.parentNode;
	var heightOfImage = image.offsetHeight || 150;
	var eleToReplace = d.createElement('div');
	eleToReplace.innerHTML = "<img style='width:100%;height:"
			+ heightOfImage
			+ "px;'></img><div style='z-index:9999;text-align:center;width:100%;margin-bottom:5px;font-size:12px;color:#A9A9A9;position:relative;bottom:15px;'>点击加载图片</div>";
	eleToReplace.onclick = function() {
		image.src = src;
		parentNode.replaceChild(image, eleToReplace);
	};
	parentNode.replaceChild(eleToReplace, image);
};
var getAttribute = function(ele, attrName) {
	if (!ele || !ele['attributes'] || !attrName) {
		return "";
	}
	var attributes = ele['attributes'];
	var attr = attributes[attrName];
	if (!attr || !attr.value) {
		return "";
	}
	return attr.value;
};
var shouldDownloadImage = function() {
	var shouldDownload = window.article.shouldDownloadImages();
	return shouldDownload;
};
var trySendContentSizeChangedMessage = function() {
	if (previousContentHeight != d.body.scrollHeight) {
		previousContentHeight = d.body.scrollHeight;
	}
};

var attachClickEventToImage = function(image, indexOfImage){
     image.addEventListener("click", function(event){
         article.showBigImages(image.src, indexOfImage);
         return false;
     });
 };

documentReady();
